Box = Core.class()

function Box:init(name, world, w, h)
	self.world = world
	self.shape = TRect.new(0, 0, w, h)
	self.shape.name = name
	self.world:add(self.shape)
end

---------------------
------ OVERIDE ------
---------------------
function Box:setPtr(ptr) self.shape.ptr = ptr end

function Box:setRotation(angle) 
	self.shape:setRotation(angle)
	self.world:update(self.shape, self.shape.pos:unpack())
end

function Box:setPosition(x, y) 
	self.world:update(self.shape, x, y)
end

function Box:setX(x) 
	self.world:update(self.shape, x, self:getY())
end

function Box:setY(y) 
	self.world:update(self.shape, self:getX(), y)
end


function Box:rotateAround(angle, x, y)
	self.shape.pos:rotateAround(angle, {x=x, y=y})
	self.world:update(self.shape, self.shape.pos.x, self.shape.pos.y)
end

function Box:faceTo(vec, additionalRotation)
	local ang = self.shape.pos:angle(vec)
	self.shape:setRotation(ang + additionalRotation or 0)
end

function Box:getPosition() return self.shape.pos.x, self.shape.pos.y end

function Box:getX() return self.shape.pos.x end

function Box:getY() return self.shape.pos.y end

function Box:getRotation() return self.shape.rotation end